



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>使用POI进行Excel操作的总结一——创建Workbook，Sheet，Row以及Cell</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">使用POI进行Excel操作的总结一——创建Workbook，Sheet，Row以及Cell</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-21 16:46:21 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>前段时间，看在其他的网站上给出Excel文档的导入与导出操作，感觉很酷的样子，所以就学习了一下如何使用POI进行Excel的操作，现在对之前的学习过程进行一个总结。</p>
<p>一、现在普遍使用的Excel文档有xls以及xlsx这两种Excel文档，其中xls格式的Excel文档又分为5.0/95工作簿以及97-2003工作簿这两种。需要注意的是，由于5.0/95工作簿的版本太低，现在的POI文档不再支持这种类型的Excel文档的读取工作，当试图读取这种类型的Excel文档的时候，POI会抛出一个异常（OldExcelFormatException）。我现在使用的POI是3.14版本。</p>
<p>二、Workbook的创建</p>
<p>1、由于Excel中存在xls以及xlsx这两种格式，所以创建方式也有所不同。其中对于xls格式的文档，需要使用HSSFWorkbook来创建工作簿对象，而对于xlsx格式的Excel文档，则需要使用XSSFWrokbook来创建工作簿。有一点需要注意的是，HSSFWorkbook与XSSFWorkbook这两个类其实都是Workbook接口的一个实现类。好了，下面就是创建工作簿对象的代码：</p>
<div>
<pre class="prettyprint linenums">    //创建一个不存在的excel文件<br />
    private static Workbook createWorkbookIfNotExist(String fileName) throws Exception {<br />
        Workbook wb = null;

        if(fileName.endsWith(".xls")) {<br />
            wb = new HSSFWorkbook();<br />
        } else if(fileName.endsWith(".xlsx")) {<br />
            wb = new XSSFWorkbook();<br />
        } else {<br />
            throw new Exception("文件类型错误！");<br />
        }

        try{<br />
            OutputStream output = new FileOutputStream(fileName);<br />
            wb.write(output);<br />
        }catch(FileNotFoundException e) {<br />
            System.out.println("文件创建失败，失败原因为：" + e.getMessage());<br />
            throw new FileNotFoundException();<br />
        }<br />
        System.out.println(fileName + "文件创建成功！");

        return wb;<br />
    }

    //创建一个新的或者已存在的Excel文档的Workbook<br />
    public static Workbook createWorkbook(String fileName) throws Exception {<br />
        InputStream input = null;<br />
        Workbook wb = null;

        try{<br />
            input = new FileInputStream(fileName);<br />
            wb = WorkbookFactory.create(input);<br />
        } catch(FileNotFoundException e) {<br />
            System.out.println("要打开的文件不存在，正试图创建该文件，请稍后&hellip;&hellip;！");<br />
            wb = createWorkbookIfNotExist(fileName);<br />
        } catch(OldExcelFormatException e) {<br />
            System.out.println("文件打开失败，原因：要打开的Excel文件版本过低！");<br />
            throw new OldExcelFormatException("文件版本过低");<br />
        } finally {<br />
            if(input != null) {<br />
                input.close();<br />
            }<br />
        }

        return wb;<br />
    }</pre>
</div>
<p>2、创建Sheet的时候，同样的也存在HSSFSheet以及XSSHSheet这两种类型。同样的HSSFSheet以及XSSFSheet这两个类也是Sheet接口的实现类。如果直接使用实现类进行创建Sheet的话，那么，对于不同的格式，需要使用不同的实现方式，尽管实现的方式都一致。由于Java的多态关系，在这里，我使用Sheet接口进行处理。代码：</p>
<div>
<pre class="prettyprint linenums">    //创建sheet<br />
    public static Sheet createSheet(Workbook wb , String sheetName) {<br />
        Sheet sheet = wb.getSheet(sheetName);

        if(sheet == null) {<br />
            System.out.println("表单" + sheetName + "不存在，试图创建该sheet，请稍后&hellip;&hellip;");<br />
            sheet = wb.createSheet(sheetName);<br />
            System.out.println("名为" + sheetName +"的sheet创建成功！");<br />
        }

        return sheet;<br />
    }</pre>
</div>
<p>3、对于Row的创建，也是一样，也是使用Row这个接口进行实现。代码：</p>
<div>
<pre class="prettyprint linenums">    //创建行row<br />
    public static Row createRow(Sheet sheet , int rowNum) {<br />
        Row row = sheet.getRow(rowNum);

        if(row == null) {<br />
            System.out.println("行号为：" + rowNum + "的行不存在，正试图创建该行，请稍后&hellip;&hellip;");<br />
            row = sheet.createRow(rowNum);<br />
            System.out.println("行号为：" + rowNum + "的行创建成功！");<br />
        }

        return row;<br />
    }</pre>
</div>
<p>4、对于Cell也是一样，同样使用Cell接口进行编程。代码：</p>
<div>
<pre class="prettyprint linenums">   //创建单元格cell<br />
    public static Cell createCell(Row row , int cellNum) {<br />
        Cell cell = row.getCell(cellNum);

        if(cell == null) {<br />
            System.out.println("该单元格不存在，正在试图创建该单元格，请稍后&hellip;&hellip;");<br />
            cell = row.createCell(cellNum);<br />
            System.out.println("该单元格创建成功！");<br />
        }

        return cell;<br />
    }</pre>
</div>
<p>以上几个操作就是Workbook、Sheet、Row以及Cell的创建工作。另外，当对Excel文档操作完成之后，需要使用Workbook的write方法保存一下，然后上述的改动才会保存在你创建的Excel文档中。代码：</p>
<div>
<pre class="prettyprint linenums">wb03.write(new FileOutputStream("C:\\Users\\Administrator\\Desktop\\03styleExcel.xls"));<br />
wb07.write(new FileOutputStream("C:\\Users\\Administrator\\Desktop\\07styleExcel.xlsx"));</pre>
</div>
<p>其中wb03就是使用上述方法创建的xls格式的Excel文档，wb07则是xlsx格式的文档。</p>
<p>好了，这篇博文到这里就结束了。如果文章中有什么错误或不足的地方，希望各位大侠多多指点。后面的博文，会陆续介绍如何往Excel文档中写入不同格式的数据，以及边框、图片、合并单元格、隐藏与显示行等操作。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/g8eo3veq.html">linux 常用命令学习记录</a>
		</li>
						<li><a href="https://www.batexi.com/a/495dkk6q.html">iOS中UITableView使用总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jw5y48.html">Java线程中run和start方法的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdl6x38.html">Visual Studio 2012 &lbrack;ADO&period;NET 实体数据模型&rsqb;丢失没有的解决方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7m1wrxq.html">Python之路【第十七篇】：Django之【进阶篇】</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjre5k8.html">jQuery对象的创建（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzr7re8.html">ThreadLocal原理</a>
		</li>
						<li><a href="https://www.batexi.com/a/90m0xyn8.html">H5 仿ios select滚动选择器。框架。</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o14ly5q.html">netsh winsock reset命令，作用是重置 Winsock 目录</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2r1ez9.html">一个完整的Java程序示例</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kj7j3r9.html">&period;NET界面控件DevExpress全新发布v18&period;2&period;6&vert;附下载</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvpmx28.html">网易云课堂Dubbo学习笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwz7yy8.html">Redis-环境搭建</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql10rve9.html">JSP 隐含对象</a>
		</li>
						<li><a href="https://www.batexi.com/a/qx27y5d8.html">&lbrack;转&rsqb;50 Tips for Working with Unity &lpar;Best Practices&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnn3vmgq.html">&lbrack;COGS2427&rsqb;&lbrack;HZOI 2016&rsqb;seq</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o47lkeq.html">js 的push方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwl6g239.html">TP5安装失败怎么办？</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1vgry6q.html">docker 不同机器上容器互相通信</a>
		</li>
						<li><a href="https://www.batexi.com/a/90dvygn8.html">《DSP using MATLAB》示例Example7&period;2</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9gmvpge9.html">STM32F10x 学习笔记5（USART实现串口通讯 1）</a>
			</li>
						<li><a href="https://www.batexi.com/a/96owmev9.html">掌握 Linux 调试技术</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mn7d1oq.html">rsync命令来实现将服务器端的文件备份到客户端</a>
			</li>
						<li><a href="https://www.batexi.com/a/qydj42jq.html">poj2228</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e1l5pz9.html">【转】寻找最好的笔记软件&colon;三强篇&lpar;EverNote、Mybase、Surfulater&rpar; &lpar;v1&period;0&rpar; &lpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qde4zej9.html">关于DocumentCompleted事件</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlm3w5x9.html">Java 热部署深入探索</a>
			</li>
						<li><a href="https://www.batexi.com/a/qn1zgwg8.html">centos 5 yum安装与配置vsFTPd FTP服务器</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7my2yeq.html">Linux 环境变量 &dollar;PATH</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7myj2kq.html">JS常用扩展</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
